package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0021;
import cn.ibizlab.core.sample.filter.IBIZSample0021SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0021Mapper extends BaseMapper<IBIZSample0021> {


    Page<IBIZSample0021> searchDefault(IPage page, @Param("ctx") IBIZSample0021SearchContext context, @Param("ew") Wrapper<IBIZSample0021> wrapper);
    List<IBIZSample0021> listDefault(@Param("ctx") IBIZSample0021SearchContext context, @Param("ew") Wrapper<IBIZSample0021> wrapper);

    @Override
    IBIZSample0021 selectById(Serializable id);

    IBIZSample0021 selectEntity(IBIZSample0021 entity);

    List<IBIZSample0021> selectEntities(@Param("list") List<IBIZSample0021> list);

    @Override
    int insert(IBIZSample0021 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0021 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0021 entity, @Param("ew") Wrapper<IBIZSample0021> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0021> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}